/**
 *
 */
package de.intevation.gnv.transition.profile.vertical;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Collection;

import de.intevation.gnv.chart.ChartLabels;
import de.intevation.gnv.chart.ChartStyle;
import de.intevation.gnv.chart.VerticalProfileChartFactory;
import de.intevation.gnv.chart.exception.TechnicalChartException;
import de.intevation.gnv.statistics.Statistics;
import de.intevation.gnv.statistics.TimeseriesStatistics;
import de.intevation.gnv.statistics.VerticalProfileStatistics;
import de.intevation.gnv.transition.describedata.KeyValueDescibeData;
import de.intevation.gnv.transition.timeseries.TimeSeriesOutputTransition;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class VerticalProfileOutputTransition extends TimeSeriesOutputTransition {
    /**
     * The UID of this class
     */
    private static final long serialVersionUID = 4401516087492028840L;

    /**
     * Constructor
     */
    public VerticalProfileOutputTransition() {
        super();
        super.domainLable = "Tiefe";
    }

    /**
     * @see de.intevation.gnv.transition.timeseries.TimeSeriesOutputTransition#getMeasurements()
     */
    @Override
    protected Collection<KeyValueDescibeData> getMeasurements() {
        String collectionName = "dateid";
        return this.getCollection(collectionName);
    }
    
    /**
     * @see de.intevation.gnv.transition.timeseries.TimeSeriesOutputTransition#createChart(java.io.OutputStream, java.util.Collection, java.util.Collection, java.lang.String, de.intevation.gnv.chart.ChartStyle, de.intevation.gnv.chart.ChartLabels)
     */
    @Override
    protected void createChart(OutputStream outputStream,
            Collection<KeyValueDescibeData> parameters,
            Collection<KeyValueDescibeData> measurements,
            ChartStyle chartStyle, ChartLabels chartLables,String uuid) throws IOException, TechnicalChartException {
        VerticalProfileChartFactory chartFactory = new VerticalProfileChartFactory();
        chartFactory.createSimpleVerticalProfileChart(chartLables, chartStyle, 
                                                 parameters, measurements, 
                                                 outputStream, this.getChartResult(uuid));
    }

    /**
     * @see de.intevation.gnv.transition.timeseries.TimeSeriesOutputTransition#getStatisticsGenerator()
     */
    @Override
    protected Statistics getStatisticsGenerator() {
       return new VerticalProfileStatistics();
    }
    

}
